<template>
    <div class="category">
        <button class="ui right floated button positive" v-on:click="open('#addCategory')">+ Add new category</button>
        <h1>Categories</h1>

        <table class="ui table">
            <thead>
            <tr>
                <th class="id">#</th>
                <th>Category</th>
            </tr>
            </thead>
            <tbody>
            <tr v-for="category in categories">
                <td class="id">{{category.id}}</td>
                <td><a href="javascript:void(0);" @click="show(category.id)">{{category.name}}</a></td>
            </tr>
            </tbody>
        </table>

        <div class="ui modal" id="addCategory">
            <i class="close icon"></i>
            <div class="header">
                Add category
            </div>
            <div class="content">
                <form class="ui form">
                    <div class="field">
                        <label>Category</label>
                        <input ref="category_name" :value="category.name"/>
                    </div>
                </form>
            </div>
            <div class="actions">
                <div class="ui primary button" @click="close('#addCategory')">
                    Close
                </div>
                <div class="ui positive button" @click="save()">
                    Save
                </div>
            </div>
        </div>

        <div class="ui modal" id="viewCategory">
            <i class="close icon"></i>
            <div class="header" v-if="showModal">
                Category: #{{ category.id }} - {{ category.name }}
            </div>
            <div class="content" v-if="showModal">
                <h3>Products</h3>
                <ul>
                    <li v-for="product in category.products">{{product.name}}</li>
                </ul>
            </div>
            <div class="actions">
                <div class="ui primary button" @click="close('#viewCategory')">
                    Close
                </div>
            </div>
        </div>

    </div>
</template>

<script>
    export default {
        name: "category",
        data() {
            return {
                showModal: false,
                categories: null,
                category: {
                    id: null,
                    name: null
                },
            };
        },
        mounted() {
            return this.$http.get('./api/category/list.json').then((response) => {
                this.categories = response.body;
            }, function () {
                alert('Error');
            });
        },
        methods: {
            show(id) {
                this.$http.get('./api/category/read/' + id).then((response) => {
                    this.category = response.body;
                    this.open('#viewCategory');
                }, function () {
                    alert('error');
                });
            },
            save() {
              this.$http.post('./api/category/create', {name: this.$refs['category_name'].value}).then((response) => {
                  this.categories = response.body;
              }, function() {
                  alert('error');
              });
            },
            open(element) {
                this.showModal = true;
                jQuery(element).modal('show');
            },
            close(element) {
                this.showModal = false;
                jQuery(element).modal('hide');
            }
        }
    }
</script>

<style scoped>
    th.id, td.id {
        width: 5%;
    }
</style>